def listPerType(typeObj):
# cam, geo, alembicarchive, envlight, null
    listObj = []
    node = hou.node("/")
    scanChildren( node, typeObj, listObj)
    return listObj
    
def scanChildren(node, typeObj, listObj):
    for n in node.children():
#        print('--%d %s %s'%(n.isGenericFlagSet(hou.nodeFlag.Lock), typeObj, n.type().name()))
        if n.type().name() == typeObj :
            listObj.append(n)
#            print('=======================')
        if n.isGenericFlagSet(hou.nodeFlag.Lock) == False :              
            scanChildren(n, typeObj, listObj)
    return listObj
    
#listPerType('filecache')    

from PySide2 import QtCore
from PySide2 import QtWidgets
import hou
class SelectByType(QtWidgets.QWidget):
    def __init__(self, parent=None):
        QtWidgets.QWidget.__init__(self, parent)

        hbox = QtWidgets.QGridLayout()
        self.hbox = hbox
        
        self.setGeometry(250, 300, 100, 140)
        self.setWindowTitle('select by type')

        buttonFindType = QtWidgets.QPushButton('find type', self)
        buttonFindType.setFocusPolicy(QtCore.Qt.NoFocus)
#        buttonFindType.setGeometry(QtCore.QRect(20, 10, 50, 70))
        
        buttonList = QtWidgets.QPushButton('list all', self)
        buttonList.setFocusPolicy(QtCore.Qt.NoFocus)
#        buttonList.setGeometry(QtCore.QRect(20, 70, 50, 70))
        
        buttonSelect = QtWidgets.QPushButton('select all', self)
        buttonSelect.setFocusPolicy(QtCore.Qt.NoFocus)
#        buttonSelect.setGeometry(QtCore.QRect(90, 70, 50, 70))
        
        buttonDelete = QtWidgets.QPushButton('delete all', self)
        buttonDelete.setFocusPolicy(QtCore.Qt.NoFocus)
#        buttonDelete.setGeometry(QtCore.QRect(180, 70, 50, 70))        




        self.connect(buttonFindType, QtCore.SIGNAL('clicked()'), self.findTypeDialog)
        self.connect(buttonList  , QtCore.SIGNAL('clicked()'), self.listTypeDialog)   
        self.connect(buttonSelect  , QtCore.SIGNAL('clicked()'), self.selectTypeDialog)   
        self.connect(buttonDelete  , QtCore.SIGNAL('clicked()'), self.deleteTypeDialog)           

        self.label = QtWidgets.QLabel('type to find', self)
#        self.label.move(130, 10)
        
        self.text = QtWidgets.QLineEdit()
        self.text.setMinimumWidth(300)
        self.text.setText('select an object click on find type or enter nodeType')
        

        hbox.addWidget(self.label, 0, 0)
        hbox.addWidget(self.text, 0, 1, 1, 2) 
        hbox.addWidget(buttonFindType, 0, 3)        
        hbox.addWidget(buttonDelete, 1, 0)
        hbox.addWidget(buttonSelect, 1, 1)        
        hbox.addWidget(buttonList, 1, 2)  
        self.setLayout(hbox)

    def  findTypeDialog(self):
        selected = hou.selectedNodes()
        self.text.setText(selected[0].type().name())
        return
        
    def listTypeDialog(self):   
        typeToSelect = self.text.text()
        allObjects = listPerType(typeToSelect)
        print('list of all %s in the scene'%typeToSelect)
        for obj in allObjects:
            print('%s %s'%(obj, obj.path()))
        print('=====================================')  
        self.close()
        return        

    def selectTypeDialog(self):   
        typeToSelect = self.text.text()
        allObjects = listPerType(typeToSelect)
        print('select of all %s in the scene'%typeToSelect)
        for obj in allObjects:
            obj.setSelected(True)
        self.close()
        return    
        
    def deleteTypeDialog(self):   
        typeToSelect = self.text.text()
        allObjects = listPerType(typeToSelect)
        print('delete all %s in the scene'%typeToSelect)
        for obj in allObjects:
            obj.destroy()
        self.close()
        return   
        
    def showDialog(self):
        ok, font = QtWidgets.QFontDialog.getFont()
        if ok:
            self.label.setFont(font)

dialog = SelectByType()
dialog.show()